<?php

echo '<pre>';
$config = parse_xml_file('config.xml');
print_r($config);

function parse_xml_file($file) {

	$data = file_get_contents($file);

	$xml_parser = xml_parser_create();
	xml_parse_into_struct($xml_parser, $data, $values, $index);
	$xml_error = xml_get_error_code($xml_parser);
	if ($xml_error)
		echo xml_error_string($xml_error);
	xml_parser_free($xml_parser);

	array_shift($values);			// don't need this one

	$a = get_section($values,$index);

	return $a;
}

function get_section(&$values,$index) {

	$a = array();

	while ($val = array_shift($values)) {
		if ($val['type'] == 'complete') {
			$v = strtolower($val['tag']);
			$d = (isset($val['value'])) ? $val['value'] : '';
			$a[$v] = trim($d);
		}
		if ($val['type'] == 'close') {
			break;
		}
		if ($val['type'] == 'open') {
			$v = strtolower($val['tag']);
			$a[$v][] = get_section($values,$index);
		}
	}

	return $a;
}

function ini_to_xml($file, $name, $options = 1) {

	$file = file($file);

	$xml = "<?xml version=\"1.0\"?>\n<$name>\n";
	foreach ($file as $line) {
		$line = trim($line);
		if (strpos($line,';') === 0 || $line == '')
			continue;
		preg_match('/(\w*)\s*=\s*(.*)/',$line,$res);
		$tag = $res[1];
		$val = $res[2];
		if ($options & 1)
			$val = trim($val,'"');
		$val = htmlspecialchars($val);
		$xml .= "\t<$tag>$val</$tag>\n";
	}
	$xml .= "</$name>\n";

	return $xml;
}
